; Hey emacs! This file is -*-mode: Emacs-Lisp; coding: iso-2022-jp-unix; tab-width: 4;-*- .
;
; Function   : Subroutine Navigator mode
; Project    : MARUHA GEDON
;              (The worst jokes with the best technologies. since 1991.)
; SubProject : SUBROUTINE NAVIGEDON
; Version    : $Id: navi.el,v 1.34 1999/10/02 08:01:12 suna Exp $
; Author     : GEDON No.2 Sunagawa Youichi <suna@love.email.ne.jp>
; PatchAuthor: GEDON No.1 TKS <tks@love.email.ne.jp>
;            : Ikeda Takashi
;            : Masafumi Matsumura <mmatsu@roy.hi-ho.ne.jp>
; WhereToGet : http://www.ne.jp/asahi/love/suna/pub/soft/navi.el/index.html   ( japanese )
;              http://www.ne.jp/asahi/love/suna/pub/soft/navi.el/index-e.html ( english )
; Report     : Bugs, improvement, comment to navi.el, send e-mail to suna@love.email.ne.jp.
;              Since native language of me is Japanese and Klingon,
;              language of e-mail is prefferable in japanese or klingon. 
;              I can read and write english a little, e-mail in english is also acceptable.
;
;              I enlist you as a PatchAuthor in case your patch adapted to navi.el.
;              So, chose one you like to enlisted.
;              1) Name only.
;                 ex) Foo Var, Hoge Hoge,
;              2) Name and e-mail.
;                 ex) Foo Var <foo@var.var.var>, Hoge Hoge <hoge@mogomogo>
;              3) Other nickname.
;                 ex) Kenshirou, Mr Spock

; [navi-mode]
;
; etag$B$NMM$J5!G=!#(B
; $B%=!<%9%U%!%$%k$rJ8;zNs2r@O$7$F!"4X?t$rCj=P$7!"0lMw%&%#%s%I%&$K%j%9%H%"%C%W$9$k!#(B
; $B%j%9%H%"%C%W$7$?>pJs$r85$K!"J8;zNs8!:w$G!"4X?t$N@hF,$K%+!<%=%k$r0LCV$E$1$k!#(B
;
; $B%b!<%IL>$r8+$k$N$G!"(B"C++","C","Pascal","Java","Emacs-Lisp","Lisp Interaction","Perl","CPerl","TeX","Text","HTML","Ruby"
; $B$N$$$:$l$+$N%b!<%I$K$J$C$F$$$k$3$H$,I,MW!#(B

; [navi-mode]
; 
; Like etag, navi.el parse source file with regular expression, then list and jump by function declaration.
; 
; navi.el depend on mode name.
; It must be one of "C++","C","Pascal","Java","Emacs-Lisp","Lisp Interaction","Perl","CPerl","TeX","Text","HTML","Ruby".
;
; navi.el positions source-window to specific function declaration with regular expression that selected in listing-window.
; So, if there are two functions same name in source-window, navi.el positions the first one.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B!Z(B.emacs$B$+$i$N%+%9%?%^%$%:J}K!![(B
;
;$B#1!%4X?t0lMw%&%#%s%I%&$N%G%U%)%k%H9T?t$rJQ$($k!#(B
;
;(setq navi-listing-window-height 10)
;
;$B#2!%(Bnavi-mode$B$N8F$S=P$7$r%-!<$K3d$jEv$F$k!#(B
;
;(global-set-key [f11] 	   'call-navi)
;(global-set-key "\C-x\C-l" 'call-navi)
;(defun call-navi ()
;  (interactive)
;  (navi (buffer-name))
;  )
;$B#3!%%G%U%)%k%HCM(B
; $B2<5-$N(B defvar $B$NCM$r(B .emacs $B$G(B setq $B$GJQ99$7$F$/$@$5$$!#(B

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; [how to customize your .emacs]
;
;1.default height of listing-window
;
;(setq navi-listing-window-height 10)
;
;2.key stroke to evoke navi-mode
;
;(global-set-key [f11] 	   'call-navi)
;(global-set-key "\C-x\C-l" 'call-navi)
;(defun call-navi ()
;  (interactive)
;  (navi (buffer-name))
;  )
;
;3.other values
; change these values in your .emacs.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; $B$3$3$+$i(B
;; start

; $B3F%b!<%I$4$H$N(B($B8@8l$4$H$N(B)$B4X?tL>$r8!:w$9$k$?$a$N@55,I=8=!#(B
; mode specific regular expressions
(defvar navi-search-exp-c    ; for C and C++ mode
  "\\(^[^ \t\n#/\\*]+[0-9a-zA-Z_ \t\\*]+([^\n;]*\\)$")
(defvar navi-search-exp-lisp	; for Lisp Interaction and Emacs-Lisp mode.
  "^\\([ \t]*(defun[ \t]+.*\\)$")						; "(defun" only
;  "^\\([ \t]*(\\(defun\\|defcustom\\|defvar\\|defgroup\\)[ \t]+.*\\)$")	; (defun an (defvar ,,,,,
(defvar navi-search-exp-perl	; for Perl and CPerl mode.
  "^\\([ \t]*sub[ \t]+.*\\)$")
(defvar navi-search-exp-ruby	; for Ruby mode.
  "^\\([ \t]*\\(class\\|module\\|def\\|alias\\)[ \t]+.*\\)$")
(defvar navi-search-exp-html	; for HTML mode.
      "^\\([ \t]*<[Hh][123456].*\\|[ \t]*<[Hh][Ee][Aa][Dd].*\\|[ \t]*<[Bb][Oo][Dd][Yy].*\\|[ \t]*<[Ff][Oo][Rr][Mm].*\\)$")
(defvar navi-search-exp-text	; for Text mode.
  "^\\([ \t]*[1234567890$B#1#2#3#4#5#6#7#8#9#0(B]+[\.]+.*\\)$")
(defvar navi-search-exp-tex		; for TeX mode.
  "^\\(\\\\chapter.*\\|\\\\section.*\\|\\\\subsection.*\\|\\\\subsubsection.*\\)$")
(defvar navi-search-exp-pascal	; for Pascal mode. (I will buy Borland Delphi for Linux!)
  "^\\([Pp][Rr][Oo][Cc][Ee][Dd][Uu][Rr][Ee].*\\)$")
(defvar navi-search-exp-java	; for Java mode.
  "\\(^[ \t]*[^\n#/\\*=]+[0-9a-zA-Z_ \t\\*,\.()]+{[^\n;]*\\)$")
(defvar navi-search-exp-diff	; don't use. experimental.
  "^\\(^[0-9*]+.*\\)$")

;$B$"$H!"4X?t%&%#%s%I%&$N(Bheight$B$O!"JQ?t$G$7$F$$$7$?$$$J!#(B
(defvar navi-listing-window-height 5)		;$B4X?t0lMw%&%#%s%I%&$N9b$5(B
(defvar navi-listing-window-shrink-size 1)	;$BBg$-$5$rJQ$($k;~$NA}J,(B
(defvar navi-source-window-scroll-size 1)	;$B%=!<%9%&%#%s%I%&$r%9%/%m!<%k$9$kA}J,(B

; $B0lMw%&%#%s%I$G$N?'(B
(defvar navi-color-mode "black")	;$B%b!<%I$N?'(B
(defvar navi-color-file "blue")		;$B%U%!%$%kL>$N?'(B
(defvar navi-color-func "red")		;$B4X?tDj5A$N?'(B

;; end
;; $B$3$3$^$G(B
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B!Z@)8B;v9`![(B
;
; $B#1!%%b!<%IL>(B
;
;	$B%=!<%9$N<oN`$rH=CG$9$k$?$a$K!"%=!<%9%&%#%s%I%&$N%b!<%IL>$r;2>H$9$k$N$G!"(B
;	$B%=!<%9%&%#%s%I%&$OE,@Z$J%b!<%I$K$J$C$F$$$kI,MW$,$"$k!#(B
;
; $B#2!%4X?tCj=P(B
;
;	$B4X?t$NCj=P$O!"%=!<%9$r@55,I=8=$G8!:w$9$k$N$G!"%G%U%)%k%H$N@55,I=8=$K(B
;	$B%^%C%A$7$J$$=q$-J}$r$9$k$H!"4X?t$H$7$FG'<1$5$l$J$$!#(B
;	$BNc$($P!"#C8@8l$G4X?t$N$O$8$^$j$N9T$K:8%9%Z!<%9$,B8:_$9$k>l9g$J$I!#(B
;
; $B#3!%4X?t$X$N0LCV$E$1(B
;
;	$BF1$84X?t$r#2$D@k8@$9$k!"$"$k$$$O!"4X?t%W%m%H%?%$%W@k8@$J$I$G!"(B
;	$B4X?t$N0LCV$,6hJL$G$-$J$$>l9g!"@h$K=P8=$7$?9T$K0LCV$E$/$3$H$,$"$k!#(B
;
; $B#4!%%P%C%U%!$r(Bkill$B$7$?8e$N0LCV$E$1(B
;
;	$B0lMw%&%#%s%I%&:n@.8e!"%=!<%9%&%#%s%I%&$r(Bkill$B$9$k$H!"4X?t$X$N(B
;	$B0LCV$E$1$O<:GT$9$k!#(B
;
; $B#5!%(Bemacs$B$N%P!<%8%g%s(B
;
;	emacs20.4 $B0J30$N%P!<%8%g%s$G$OF0:n$7$J$$>l9g$,$"$k!#(B
;	(mule2.3(emacs 19.28)$B$G$OF0:n$7$F$$$k!#(B)
;
; 6. Java$B$N4X?t$N0LCV$E$1J}K!(B
;
;	$B$^$@$^$@2x$7$$!#(B
;	$B9)IW2~A1$NM>COB?!9M-$j!#(B

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B!Z3HD%M=Dj![(B
; $B#1!%%P%C%U%!$r(Bkill$B$7$?8e$N0LCV$E$1(B
;	$B%P%C%U%!$rI|85$7$F!"0LCV$E$1$k!#(B
;
; $B#2!%BP1~%b!<%I$N3HD%(B
;	Pascal, VisualBasic, COBOL, LaTeX $B$XBP1~$9$k!#(B

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; $B0J2<$N#3$D$NJQ?t$O%=!<%9$rM}2r$7$F$$$k?M$,JQ99$9$k$H!"JXMx$G$7$g$&!#(B

(defvar navi-listing-format        "%s:%s:%s\n")
					; $B4X?t0lMw%&%#%s%I%&$N%U%)!<%^%C%H(B

;(defvar navi-listing-clean-format  "%s:%s:")
(defvar navi-listing-clean-format  "%s:%s:")
					; $B>e5-$N%U%)!<%^%C%H$N9T$r:o=|$9$k$?$a$N%U%)!<%^%C%H(B
					; $BCm0U!'@55,I=8=$G$O$J$$$h!#(B

(defvar navi-listing-search-exp "^[ ]*\\([^:]*\\)[ ]*:[ ]*\\([^: ]*\\)[ ]*:\\(.*\\)")
					; $B4X?t0lMw%&%#%s%I%&8!:wMQ$N@55,I=8=!#(B
					; (match-beginning nn) (match-end nn)$B$N(Bnn$B$O#1!A#3(B

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B0J2<$OJQ99IT2D(B

(defvar navi-listing-window-name "*Subroutine Navigator*") ; $B4X?t0lMw%&%#%s%I%&$N%P%C%U%!L>(B
(defvar navi-listing-mode-name	 "Navi")		   ; $B4X?t0lMw%&%#%s%I%&$N%b!<%IL>(B

(defvar navi-search-mode-name "")	; $B%=!<%9$N%b!<%IL>$r3JG<$9$k%P%C%U%!(B


(defvar navi-pair-alist nil)		; $B4X?t0lMw$N%U%!%$%kL>$H%P%C%U%!$N%U%!%$%kL>$r3JG<$9$k!#(B

(defvar navi-separator-regexp "^:")	; $BDj5A%U%!%$%k$NFbMF$N%;%Q%l!<%?!<(B

(defvar navi-version-rcs "$Id: navi.el,v 1.34 1999/10/02 08:01:12 suna Exp $")
(defvar navi-version-deffile "1")	; $BBP1~$7$F$$$kDj5A%U%!%$%k$N7A<0$N%P!<%8%g%s(B
(defvar navi-version-gedon   "1")	; SUBROUTINE NAVIGEDON $B%5%V%W%m%8%'%/%H>e$N%P!<%8%g%s(B

(defvar navi-mode-map nil)
(if navi-mode-map
    ()
  (setq navi-mode-map (make-sparse-keymap))
  (define-key navi-mode-map "\C-n"	'navi-next			)
  (define-key navi-mode-map "\C-o"	'navi-open-other-window		)
  (define-key navi-mode-map "\C-m"	'navi-open-other-window		)
  (define-key navi-mode-map " "		'navi-open-other-window		)
  (define-key navi-mode-map "\C-p"	'navi-previous			)
  (define-key navi-mode-map "d"		'navi-listing-window-delete-line)
  (define-key navi-mode-map "D"		'navi-listing-window-delete-file)
  (define-key navi-mode-map "q"		'navi-quit			)
  (define-key navi-mode-map "e"		'navi-edit			)
  (define-key navi-mode-map "o"		'navi-edit-quit			)
  (define-key navi-mode-map "k"		'navi-scroll-down-other-window	)
  (define-key navi-mode-map "j"		'navi-scroll-up-other-window	)
  (define-key navi-mode-map "b"		'navi-scroll-down-other-window-page	)
  (define-key navi-mode-map "f"		'navi-scroll-up-other-window-page	)
  (define-key navi-mode-map "n"		'navi-next-show			)
  (define-key navi-mode-map "p"		'navi-previous-show		)
  (define-key navi-mode-map "h"		'navi-hide-window		)
  (define-key navi-mode-map "2"		'navi-open-current-window	)
  (define-key navi-mode-map "^"		'navi-window-height-up		)
  (define-key navi-mode-map "v"		'navi-window-height-down	)
  (define-key navi-mode-map "s"		'navi-listing-widow-sort	)
  (define-key navi-mode-map "\C-x\C-f"	'navi-listing-widow-read-file	)
  (define-key navi-mode-map "\C-x\C-s"	'navi-listing-widow-save-file	)
  (define-key navi-mode-map "1"		'delete-other-windows		)
  )

(defun navi-gedon-version ()
  (interactive)
  (message navi-version-gedon))

(defun navi-version ()
  (interactive)
  (message navi-version-rcs))

(defun navi-scroll-up-other-window-page ()
  "$B%=!<%9%&%#%s%I%&$r#1%Z!<%8%9%/%m!<%k%"%C%W$9$k!#(B"
  (interactive)
  (save-restriction
   (save-excursion
     (select-window (next-window))
     (scroll-up)
     (select-window (previous-window)))))

(defun navi-scroll-down-other-window-page ()
  "$B%=!<%9%&%#%s%I%&$r#1%Z!<%8%9%/%m!<%k%@%&%s$9$k!#(B"
  (interactive)
  (save-restriction
   (save-excursion
     (select-window (next-window))
     (scroll-down)
     (select-window (previous-window)))))

(defun navi-scroll-up-other-window ()
  "$B%=!<%9%&%#%s%I%&$r;XDj$5$l$?9T?t%9%/%m!<%k%"%C%W$9$k!#(B"
  (interactive)
  (save-restriction
   (save-excursion
     (select-window (next-window))
     (scroll-up navi-source-window-scroll-size)
     (select-window (previous-window)))))

(defun navi-scroll-down-other-window ()
  "$B%=!<%9%&%#%s%I%&$r;XDj$5$l$?9T?t%9%/%m!<%k%@%&%s$9$k!#(B"
  (interactive)
  (save-restriction
   (save-excursion
     (select-window (next-window))
     (scroll-down navi-source-window-scroll-size)
     (select-window (previous-window)))))

(defun navi-quit ()
  "$B4X?t0lMw%&%#%s%I%&$r>C5n$9$k!#(B"
  (interactive)
  ;(kill-buffer navi-listing-window-name)
  (kill-buffer (get-buffer (buffer-name)))
  (select-window (next-window))
  (delete-other-windows))

(defun navi-open-other-window ()
  "$B4X?t0lMw%&%#%s%I%&$GA*Br$7$?4X?t$r!"%=!<%9%&%#%s%I%&$N@hF,$K0LCV$E$1$k!#(B"
  (interactive)
  (navi-open t))

(defun navi-open-current-window ()
  "$B4X?t0lMw%&%#%s%I%&$r1#$7!"2hLL$r>e2<#2J,3d$9$k!#(B
$B4X?t0lMw%&%#%s%I%&$GA*Br$7$?4X?t$,>e$N%&%$%s%I%&$N@hF,$K0LCV$E$/!#(B"
  (interactive)
  (navi-open nil)
  ; $B%&%#%s%I%&$N9b$5$rD4$Y!"H>J,$K$9$k!#(B
  (let (naviHeight naviNewHeight naviFrameHeight)
    (setq naviFrameHeight (frame-height))
    (setq naviHeight (window-height))
    (setq naviNewHeight (- (/ naviFrameHeight 2) naviHeight))
    (shrink-window (- naviNewHeight) nil)))

(defun navi-open (navi-flag)
  "$B4X?t0lMw%&%#%s%I%&$GA*Br$7$?4X?t$r!"%=!<%9%&%#%s%I%&$N@hF,$K0LCV$E$1$k!#(B"
  (interactive)
  (let ((bufname "")(subname ""))
    (beginning-of-line)
    (if (re-search-forward navi-listing-search-exp (point-max) nil)
	(progn
	  (setq navi-search-mode-name (buffer-substring (match-beginning 1) (match-end 1)))
	  (setq bufname               (buffer-substring (match-beginning 2) (match-end 2)))
	  (setq subname               (buffer-substring (match-beginning 3) (match-end 3)))
	  (beginning-of-line)
	  (cond ((or (equal navi-search-mode-name "C++")
			(equal navi-search-mode-name "C"))
		 (progn 
		   (navi-show-sub-other-window-c bufname (regexp-quote subname) navi-flag)))
		((progn
		  (navi-show-sub-other-window bufname (regexp-quote subname) navi-flag)))))
      (message "not found"))))

(defun navi-show-sub-other-window (bufname subname navi-flag)
  "$B4X?t$r%=!<%9%&%#%s%I%&$N@hF,$K0LCV$E$1$k!#(B($B#C8@8l0J30$N>l9g(B)"
  (save-restriction
   (save-excursion
     (if navi-flag
	 (progn
	   (if (eq (next-window) (selected-window))
	       (split-window (selected-window) navi-listing-window-height nil))
	   (select-window (next-window))))
     (if (not (get-buffer bufname))
	 (progn
	   (find-file-noselect (navi-assoc-get-value bufname navi-pair-alist))))
     (switch-to-buffer bufname)
     (goto-char (point-min))
;     (re-search-forward (concat "^[ \t]*" subname) (point-max) nil)
     (re-search-forward (concat "^" subname) (point-max) nil)
     (set-window-start nil (match-beginning 0))
     (goto-char (match-beginning 0))
     (if navi-flag
	 (select-window (previous-window))))))

(defun navi-show-sub-other-window-c (bufname subname navi-flag)
  "$B4X?t$r%=!<%9%&%#%s%I%&$N@hF,$K0LCV$E$1$k!#(B($B#C8@8l$N>l9g(B)"
  (save-restriction
   (save-excursion
     (if navi-flag
	 (select-window (next-window)))
     (if (not (get-buffer bufname))
	 (progn
	   (find-file-noselect (navi-assoc-get-value bufname navi-pair-alist))))
     (switch-to-buffer bufname)
     (goto-char (point-min))
     (navi-show-sub-other-window-c-recurse subname)
     (set-window-start nil (match-beginning 0))
     (goto-char (match-beginning 0))
     (if navi-flag
	 (select-window (previous-window))))))

(defun navi-show-sub-other-window-c-recurse (subname)
  (let ((my-found-point)(my-end-point))
    (setq my-found-point (re-search-forward (concat "^" subname) (point-max) nil))
    (end-of-line)
  (setq my-end-point (point))
    (goto-char my-found-point)
    (if (re-search-forward ";" my-end-point t)
	(navi-show-sub-other-window-c-recurse subname))))

(defun navi-next ()
  "$B<!$N9T$K%+!<%=%k$r0\F0$9$k!#(B"
  (interactive)
  (forward-line))

(defun navi-next-show ()
  "$B<!$N9T$K%+!<%=%k$r0\F0$7!"%=!<%9%&%#%s%I%&$N@hF,$K4X?t$r0LCV$E$1$k!#(B"
  (interactive)
  (navi-next)
  (navi-open-other-window))

(defun navi-previous ()
  "$BA0$N9T$K%+!<%=%k$r0\F0$9$k!#(B"
  (interactive)
  (forward-line -1))

(defun navi-previous-show ()
  "$BA0$N9T$K%+!<%=%k$r0\F0$7!"%=!<%9%&%#%s%I%&$N@hF,$K4X?t$r0LCV$E$1$k!#(B"
  (interactive)
  (navi-previous)
  (navi-open-other-window))

(defun navi-edit ()
  "$B0lMw%&%#%s%I%&$r3+$$$?$^$^!"%+!<%=%k$r%=!<%9%&%#%s%I%&$GA*Br$7$?4X?t$K0\F0$9$k!#(B"
  (interactive)
  (navi-open-other-window)
  (select-window (next-window)))

(defun navi-edit-quit ()
  "$B0lMw%&%#%s%I%&$rJD$8!"%+!<%=%k$r%=!<%9%&%#%s%I%&$GA*Br$7$?4X?t$K0\F0$9$k!#(B"
  (interactive)
  (navi-open-other-window)
  (navi-quit))

(defun navi-mode ()
  "Subroutine Navigator
Navigate subroutines"
  (interactive)
  (kill-all-local-variables)
  (use-local-map navi-mode-map)
  (setq mode-name "Navi")
  (setq major-mode 'navi-mode)
  (set-syntax-table text-mode-syntax-table)
  (setq local-abbrev-table text-mode-abbrev-table)

  (setq buffer-file-name navi-listing-window-name)
  (setq buffer-read-only nil)
  (navi-listing-window-clear-internal-data (buffer-name))
  (navi-overlay-buffer)
  (set-buffer-modified-p nil)

  (run-hooks 'navi-mode-hook)
  (setq buffer-read-only t)
  (goto-char (point-min)))

(defun navi (b)
  "perl$B$J$I$N4X?t0lMw$rI=<(!"%J%S%2!<%H$9$k!#(B"
  (interactive "b")
  (delete-other-windows)
  (split-window (selected-window) navi-listing-window-height nil)
  (select-window (next-window))
  (if (not (equal "Navi" (buffer-name (get-buffer b))))
      (save-restriction
	(save-excursion
	  (let ((outname navi-listing-window-name)
		(inname (buffer-name (get-buffer b)))
		(end (point-max))
		(start (point-min))
		(subexp ""))
	    (setq navi-search-mode-name mode-name)
	    (cond ((equal navi-search-mode-name "Emacs-Lisp")
		   (progn 
		     (setq subexp navi-search-exp-lisp)))
		  ((equal navi-search-mode-name "Lisp Interaction") 
		   (progn 
		     (setq subexp navi-search-exp-lisp)))
		  ((or (equal navi-search-mode-name "C++")
		       (equal navi-search-mode-name "C"))
		   (progn
		     (setq subexp navi-search-exp-c)))
		  ((or (equal navi-search-mode-name "Perl")
		       (equal navi-search-mode-name "CPerl"))
		   (progn 
		     (setq subexp navi-search-exp-perl)))
		  ((equal navi-search-mode-name "Ruby")
		   (progn 
		     (setq subexp navi-search-exp-ruby)))
		  ((equal navi-search-mode-name "Text")
		   (progn 
		     (setq subexp navi-search-exp-text)))
		  ((equal navi-search-mode-name "HTML")
		   (progn 
		     (message "HTML")
		     (setq subexp navi-search-exp-html)))
		  ((equal navi-search-mode-name "TeX")
		   (progn 
		     (setq subexp navi-search-exp-tex)))
		  ((equal navi-search-mode-name "Pascal")
		   (progn 
		     (setq subexp navi-search-exp-pascal)))
		  ((equal navi-search-mode-name "Java")
		   (progn 
		     (setq subexp navi-search-exp-java)))
		  ((equal navi-search-mode-name "Diff")
		   (progn 
		     (setq subexp navi-search-exp-diff)))
		  ((t)
		   (progn (setq navi-listing-search-exp "")
			  (message "invalied mode"))))
	    (navi-lines-clean-buffer navi-search-mode-name outname inname)
	    (if (get-buffer outname)
		(display-buffer (get-buffer outname))
	      (display-buffer (get-buffer-create outname)))
	    (goto-char start)
	    (navi-overlay-make-faces)
	    (while (re-search-forward subexp end t)
	      (navi-print inname outname (buffer-substring (match-beginning 1) (match-end 1))))
	    (navi-set-alist)))))
  
  (select-window (next-window))
  (navi-mode)

  ; emacs20$B$G$O(B display-buffer$B$G%&%#%s%I%&%5%$%:$,La$C$F$7$^$&$h$&$@!#(B
  ; $B%&%#%s%I%&$N9b$5$rD4$Y!"@_DjCM$h$j$bBg$-$1$l$P!"69$a$k!#(B
  (let ((naviHeight (window-height)))
    (if (> naviHeight navi-listing-window-height)
	(shrink-window (- naviHeight navi-listing-window-height) nil)))
  (navi-overlay-buffer)
  (goto-char (point-min)))

(defun navi-print (inname outname str)
  (save-restriction
    (save-excursion
      (set-buffer (get-buffer outname))
      (if buffer-read-only
	  (setq buffer-read-only nil))
      (insert (format navi-listing-format navi-search-mode-name inname str)))))

(defun navi-overlay-buffer ()
  "$B4X?t0lMw%&%#%s%I%&$K?'$rIU$1$k!#(B"
  (interactive)
  (let (ov-mode ov-file ov-func 
	(start 0)
	(end   0)
	(bufname "")
	(subname "")
	(nbuf (get-buffer navi-listing-window-name)))
    (beginning-of-buffer)
    (while (re-search-forward navi-listing-search-exp (point-max) t)
	(progn
	  (setq ov-mode  (make-overlay (match-beginning 1) (match-end 1)))
	  (setq ov-file  (make-overlay (match-beginning 2) (match-end 2)))
	  (setq ov-func  (make-overlay (match-beginning 3) (match-end 3)))
	  (overlay-put ov-mode 'face 'navi-mode)
	  (overlay-put ov-file 'face 'navi-file)
	  (overlay-put ov-func 'face 'navi-func)))))

(defun navi-overlay-make-faces ()
  ; style of mode
  (make-face 'navi-mode)
  (copy-face 'bold 'navi-mode)
  (set-face-foreground  'navi-mode navi-color-mode)
  ; style of file
  (make-face 'navi-file)
  (copy-face 'bold 'navi-file)
  (set-face-foreground  'navi-file navi-color-file)
  ; style of function definition line
  (make-face 'navi-func)
  (copy-face 'bold 'navi-func)
  (set-face-foreground  'navi-func navi-color-func))

(defun navi-lines-clean-buffer (modename bufname filename)
  "$B%J%S%&%#%s%I%&$N(B $B!V%U%!%$%kL>!'4X?tL>!W$r%/%j%"$9$k(B"
  (save-restriction
    (save-excursion
      (if (get-buffer bufname)
	  (progn
	    (set-buffer (get-buffer bufname)); bufname is allways "Subroutine Navigator",,,, don't mind.
	    (if buffer-read-only
		(setq buffer-read-only nil))
	    (goto-char (point-min))
	    (let ((searchStr (regexp-quote (format navi-listing-clean-format navi-search-mode-name filename ""))))
	      (while (re-search-forward searchStr end t)
		(save-excursion
		  (let ((end 0)(start 0))
		    (beginning-of-line)
		    (setq start (point))
		    (end-of-line)
		    (forward-char)
		    (setq end (point))
		    (delete-region start end)
		    (beginning-of-line)
		    (setq start (point))
		    (goto-char start))))))))))

(defun navi-hide-window ()
  (interactive)
  (enlarge-window (* -1 (+ (window-height) 1))))

(defun navi-listing-widow-sort ()
  "$B4X?t0lMw%&%#%s%I%&$N%=!<%H4X?t$r4sB#$7$^$9!#(B"
  (interactive)
  (save-excursion
    (setq buffer-read-only nil)
    (sort-lines nil (point-min) (point-max))
    (setq buffer-read-only t)
    (navi-overlay-buffer)))

(defun navi-listing-widow-save-file ()
  "$B4X?t0lMw%&%#%s%I%&$r%U%!%$%k$KJ]B8$9$k!#(B"
  (interactive)
  (if (equal navi-listing-mode-name mode-name)
      (progn
	(let ((filename nil))
	  (setq filename (read-file-name "Navi SaveFile:"))
	  (if filename
	      (progn
		(navi-assoc-expand navi-listing-window-name "navi-pair-alist" navi-pair-alist)
		(setq buffer-file-name navi-listing-window-name)
		(write-region (point-min) (point-max) filename)
		(navi-listing-window-clear-internal-data navi-listing-window-name)
		(set-buffer-modified-p nil)
		(message "wrote")
		)
	    (message "need filename."))))))


(defun navi-listing-widow-read-file ()
  "$B4X?t0lMw%&%#%s%I%&$K%U%!%$%k$rFI$_9~$`!#(B"
  (interactive)
  (if (equal navi-listing-mode-name mode-name)
      (progn
	(let ((filename nil))
	  (setq filename (read-file-name "Navi ReadFile:"))
	  (if (file-exists-p filename)
	      (progn
		(setq buffer-read-only nil)
		(kill-region (point-min) (point-max))
		(insert-file-contents filename)
		(setq buffer-file-name navi-listing-window-name)
		(navi-listing-widow-read-file-parse-buffer)
		(navi-listing-window-clear-internal-data navi-listing-window-name)
		(set-buffer-modified-p nil)
		(setq buffer-read-only t)
		(navi-overlay-buffer)
		(goto-char (point-min))))))))

(defun navi-listing-widow-read-file-parse-buffer ()
  "navi-listing-widow-read-file$B$+$i$N$_8F$P$l$k!#(B"
  (let ((myMode  "")(myName  "")(myValue "")(p3start nil)(p3end   nil))
    (goto-char (point-min))
    (setq navi-pair-alist nil)
    (while (re-search-forward navi-listing-search-exp (point-max) t)
	(progn
	  (setq myMode  (buffer-substring (match-beginning 1) (match-end 1)))
	  (setq myName  (buffer-substring (match-beginning 2) (match-end 2)))
	  (setq myValue (buffer-substring (match-beginning 3) (match-end 3)))
	  (setq p3start (match-beginning 3))
	  (setq p3end (match-end 3))
	  (if (equal myMode "Navi")
	      (progn 
		(and (equal myName "navi-pair-alist")
		    (progn
		      (setq navi-pair-alist (navi-assoc-parse-add p3start p3end navi-pair-alist))))
		(and (equal myName "DefFileVersion")
		    (progn 
		      (setq subexp navi-search-exp-lisp)))))))))

(defun navi-assoc-parse-add (start end alist)
  "$B!V(BNavi:navi-pare-alist:key,value$B!W$N7A<0$N!"!V(Bkey,value$B!W$N(B
$B3+;O$H=*N;$N%]%$%s%H!"$*$h$SO"A[G[Ns$rEO$9!#(B
$BLa$jCM$O!"!V(Bkey,value$B!W$,DI2C$5$l$?O"A[G[Ns!#(B"
  (let ((asKey "")(asValue ""))
    (save-excursion
      (goto-char start)
      (if (not (re-search-forward "\\(.+\\),\\(.+\\)" nil t))
          nil
        (if (not (= (match-end 2) end))
            nil
          (setq asKey (buffer-substring (match-beginning 1) (match-end 1)))
          (setq asValue (buffer-substring (match-beginning 2) (match-end 2)))
          (cons (cons asKey asValue) alist))))))

;$B$b$7$/$O!"(B"^","v"$B$G%&%#%s%I%&(Bheight$B$,JQ$o$k$H$+(B...
;;
;; windou-height
;;
(defvar navi-window-height-line 1)
(defun navi-window-height-up()
  (interactive)
  (if (one-window-p)
      nil)
  (if (> (+ (window-height) navi-window-height-line navi-listing-window-height 2)
         (frame-height))
      nil  ;; (message "hogehoge")
    (enlarge-window navi-window-height-line)))

(defun navi-window-height-down()
  (interactive)
  (if (one-window-p)
      nil)
  (if (<= (- (window-height) navi-window-height-line) navi-listing-window-height)
      nil  ;; (message "hogehoge")
    (shrink-window navi-window-height-line)))

(defun navi-assoc-replace(key newval alist)
  (setq alist (delq (assoc key alist) alist))
  (setq alist (cons (cons key newval) alist)))

(defun navi-assoc-get-value(key alist)
  (cdr (assoc key alist)))

(defun navi-set-alist ()
  (let ((bufferName nil)(bufferFile nil))
    (setq bufferName (buffer-name))
    (setq bufferFile (buffer-file-name))
    ;(message (format "%s:%s" bufferName bufferFile))
    (setq navi-pair-alist (navi-assoc-replace bufferName bufferFile navi-pair-alist))))

(defun navi-listing-window-clear-internal-data (bufname)
  "Navi:$B$NFbIt>pJs$NJ8;zNs$r:o=|$9$k!#(B"
  (let ((myWriteOnly nil))
    (switch-to-buffer bufname)
    (setq myWriteOnly buffer-read-only)
    (setq buffer-read-only nil)
    (goto-char (point-min))
    (while (re-search-forward "^Navi:" (point-max) t)
      (save-excursion
	(let ((end 0)(start 0))
	  (beginning-of-line)
	  (setq start (point))
	  (end-of-line)
	  (forward-char)
	  (setq end (point))
	  (delete-region start end)
	  (goto-char (point-min)))))
    (setq buffer-read-only myWriteOnly)))

(defun navi-assoc-expand (bufname assocname assocvalue)
  "$BO"A[G[Ns$G;}$C$F$$$k!"%P%C%U%!$H%U%!%$%kL>$NBP1~4X78$r(B
$B%+%l%s%H%&%#%s%I%&$N@hF,$KE83+$9$k!#(B"
  (let ((alist assocvalue)(str nil)(myCar nil)(myCdr nil)(myWriteOnly nil))
    (setq myWriteOnly buffer-read-only)
    (setq buffer-read-only nil)
    ; clear version info
    (goto-char (point-min))
    (while (re-search-forward "^Navi:DefFileVersion" (point-max) t)
      (save-excursion
	(let ((end 0)(start 0))
	  (beginning-of-line)
	  (setq start (point))
	  (end-of-line)
	  (forward-char)
	  (setq end (point))
	  (delete-region start end)
	  (goto-char (point-min)))))
    (goto-char (point-min))
    (insert (format "Navi:DefFileVersion:%s\n" navi-version-deffile))
    (while (setq str (car alist))
      (setq alist (cdr alist))
      (setq myCar (car str))
      (setq myCdr (cdr str))
      (insert (format "Navi:%s:%s,%s\n" assocname myCar myCdr)))
    (setq buffer-read-only myWriteOnly)))


(defun navi-assoc-test (key)
  (interactive "sKey:")
  (message (navi-assoc-get-value key navi-pair-alist)))

(defun navi-listing-window-delete-line ()
  (interactive)
  (setq buffer-read-only nil)
  (let ((start)(end))
    (beginning-of-line)
    (setq start (point))
    (end-of-line)
    (forward-char)
    (setq end (point))
    (delete-region start end))
  (setq buffer-read-only t))

(defun navi-listing-window-delete-file ()
  (interactive)
  (setq buffer-read-only nil)
  (let ((start)(end)(modename nil)(filename nil))
    (beginning-of-line)
    (setq start (point))
    (end-of-line)
    (setq end (point))
    (if (re-search-forward navi-listing-search-exp (point-max) t)
	(progn
	  (setq modename (buffer-substring (match-beginning 1) (match-end 1)))
	  (setq filename (buffer-substring (match-beginning 2) (match-end 2)))))
    (and (not (equal modename nil))
	 (not (equal filename nil))
	 (progn
	   (navi-lines-clean-buffer modename (buffer-name) filename))))
  (setq buffer-read-only t))

(provide 'navi)
(run-hooks 'navi-load-hook)	; for your customizations
